/*  Last edited: Jan  4 20:48 1997 (badger) */
/*
 * This software has been created by Genome Research Limited (GRL). 
 * GRL hereby grants permission to use, copy, modify and distribute 
 * this software and its documentation for non-commercial purposes 
 * without fee at the user's own risk on the basis set out below.
 * GRL neither undertakes nor accepts any duty whether contractual or 
 * otherwise in connection with the software, its use or the use of 
 * any derivative, and makes no representations or warranties, express
 * or implied, concerning the software, its suitability, fitness for
 * a particular purpose or non-infringement.
 * In no event shall the authors of the software or GRL be 
 * responsible or liable for any loss or damage whatsoever arising in
 * any way directly or indirectly out of the use of this software or 
 *  its derivatives, even if advised of the possibility of such damage.
 * Our software can be freely distributed under the conditions set 
 * out above, and must contain this copyright notice.
 */
/* CMP contains standrd comparison functions for use with qsort */

#include<stdio.h>
#include<ctype.h>
#include"cmp.h"

int icmp(a,b)

int *a, *b;
{
  return *a-*b;
}

int Icmp(a,b)

int **a, **b;
{
  return **a - **b;
}

int fcmp(a,b)

float *a, *b;
{
  float x = *a - *b;
  if ( x > 0.0 )
    return 1;
  else if ( x < 0.0 )
    return -1;
  else
    return 0;
}

int Fcmp(a,b)

float **a, **b;
{
  return fcmp(*a,*b);
}

int Rstrcmp(a,b)  /* string comparison with strings reversed, case insensitive */

char *a, *b;
{
  int la = strlen(a)-1;
  int lb = strlen(b)-1;
  int n;
  while ( la && lb )
    {
      if (n = ( ((int)a[la--]) - ((int)b[lb--]) ) )
	return n;
    }
  return la-lb;
}

int Strcmp(a,b)

char **a, **b;
{
  return strcmp(*a,*b);
}


/* a version of strcmp which works with null strings */
	  
int nStrcmp(a, b )

char *a, *b;
{
  if ( a && b )
    return strcmp(a,b);
  else
    return 0;
}

int SStrcmp(a,b)

char ***a, ***b;
{
  return Strcmp(*a,*b);
}

int uscmp(a,b)

unsigned short *a, *b;
{
  return (int)(*a-*b);
}
