/*  Last edited: Jan  4 20:48 1997 (badger) */
/*
 * This software has been created by Genome Research Limited (GRL). 
 * GRL hereby grants permission to use, copy, modify and distribute 
 * this software and its documentation for non-commercial purposes 
 * without fee at the user's own risk on the basis set out below.
 * GRL neither undertakes nor accepts any duty whether contractual or 
 * otherwise in connection with the software, its use or the use of 
 * any derivative, and makes no representations or warranties, express
 * or implied, concerning the software, its suitability, fitness for
 * a particular purpose or non-infringement.
 * In no event shall the authors of the software or GRL be 
 * responsible or liable for any loss or damage whatsoever arising in
 * any way directly or indirectly out of the use of this software or 
 *  its derivatives, even if advised of the possibility of such damage.
 * Our software can be freely distributed under the conditions set 
 * out above, and must contain this copyright notice.
 */
#ifndef _IO_BUFFER_
#define _IO_BUFFER_

typedef struct io_buffer
{
  size_t size_of, max, size;
  void *buffer;
}
IO_BUFFER;


IO_BUFFER *
create_buffer( size_t max, size_t size_of );

void
destroy_buffer ( IO_BUFFER *B );

int 
buffered_fread( void *address, IO_BUFFER *B, FILE *fp );

int 
buffered_fwrite( void *address, IO_BUFFER *B, FILE *fp );


#endif
