/*  Last edited: Jan  4 20:48 1997 (badger) */
/*
 * This software has been created by Genome Research Limited (GRL). 
 * GRL hereby grants permission to use, copy, modify and distribute 
 * this software and its documentation for non-commercial purposes 
 * without fee at the user's own risk on the basis set out below.
 * GRL neither undertakes nor accepts any duty whether contractual or 
 * otherwise in connection with the software, its use or the use of 
 * any derivative, and makes no representations or warranties, express
 * or implied, concerning the software, its suitability, fitness for
 * a particular purpose or non-infringement.
 * In no event shall the authors of the software or GRL be 
 * responsible or liable for any loss or damage whatsoever arising in
 * any way directly or indirectly out of the use of this software or 
 *  its derivatives, even if advised of the possibility of such damage.
 * Our software can be freely distributed under the conditions set 
 * out above, and must contain this copyright notice.
 */
#include<stdio.h>

#define INIT   register char *sp = instring;
#define GETC() (*sp++)
#define PEEKC()     (*sp)
#define UNGETC(c)   (--sp)
#define RETURN(c)   return;
#define ERROR(c)    regerr()
#define REGEXP_BUF_SIZE 100000

#include<regexp.h>

regerr( errno )

int errno;
{
  fprintf(stderr,"\n! ERROR in regexp, code %d\n");
  exit(1);
}

char *regexp_match( instring, text, len )

char *instring, *text;
int *len;
{
  static char *last_instring=NULL;
  static char expbuf[REGEXP_BUF_SIZE];
  int eof;
  extern char *loc1, *loc2;
  
  if ( instring != last_instring )
    {
      last_instring = instring;
      compile( instring, expbuf, expbuf+REGEXP_BUF_SIZE, '\0');
    }

  if ( step( text, expbuf ) )
    {
      *len = loc2-loc1;
      return loc1;
    }
  else
    {
      *len = 0;
      return NULL;
    }


}

