/*  Last edited: Jan  4 20:48 1997 (badger) */
/*
 * This software has been created by Genome Research Limited (GRL). 
 * GRL hereby grants permission to use, copy, modify and distribute 
 * this software and its documentation for non-commercial purposes 
 * without fee at the user's own risk on the basis set out below.
 * GRL neither undertakes nor accepts any duty whether contractual or 
 * otherwise in connection with the software, its use or the use of 
 * any derivative, and makes no representations or warranties, express
 * or implied, concerning the software, its suitability, fitness for
 * a particular purpose or non-infringement.
 * In no event shall the authors of the software or GRL be 
 * responsible or liable for any loss or damage whatsoever arising in
 * any way directly or indirectly out of the use of this software or 
 *  its derivatives, even if advised of the possibility of such damage.
 * Our software can be freely distributed under the conditions set 
 * out above, and must contain this copyright notice.
 */
/*  Last edited: Oct  1 16:41 1996 (rmott) */
/* GETSEED returns a seed for the random number generator. This is by
default determined by the system clock, or optionally by the
command-line option -s=65767 etc */
/* (C) Richard Mott, ICRF */

#include<stdio.h>
#include<sys/time.h>
#include<sys/types.h>

void *calloc();

extern int comment;

int getseed( int *seed, int argc, char **argv )

{

    time_t time(), *tloc;
    int s;

    tloc = NULL;
    
    s = *seed = ((int)time(tloc))% 100000; 
    getint( "-seed", &s, argc, argv );
    *seed = s;

    /*    fprintf(stderr,"! seed = %d\n", *seed);  */

    return *seed;
}

char *Getdate() /* returns a character string containing the current date and time */
{

	time_t time(), *tloc;
	char *ctime(), *t;
	int i;
	static char temp[256];

	tloc = calloc(1,sizeof(time_t));
	time(tloc);
	sprintf( temp, "%s", ctime(tloc) );

	t = temp;
	while ( *t )
	{
		if ( *t == '\n')
			*t = 0;
		t++;
	}

	return temp;
}
